## mu-editor 1.0.1+dfsg

=== Makefile ===
XARGS := xargs -0 $(shell test $$(uname) = Linux && echo -r)
GREP_T_FLAG := $(shell test $$(uname) = Linux && echo -T)
export PYFLAKES_BUILTINS=_

all:
	@echo "\nThere is no default Makefile target right now. Try:\n"
	@echo "make run - run the local development version of Mu."
	@echo "make clean - reset the project and remove auto-generated assets."
	@echo "make pyflakes - run the PyFlakes code checker."
	@echo "make pycodestyle - run the PEP8 style checker."
	@echo "make test - run the test suite."
	@echo "make coverage - view a report on test coverage."
	@echo "make check - run all the checkers and tests."
	@echo "make dist - make a dist/wheel for the project."
	@echo "make publish-test - publish the project to PyPI test instance."
	@echo "make publish-live - publish the project to PyPI production."
	@echo "make docs - run sphinx to create project documentation."
	@echo "make translate - create a messages.pot file for translations."
	@echo "make translateall - as with translate but for all API strings."
	@echo "make win32 - create a 32bit Windows installer for Mu."
	@echo "make win64 - create a 64bit Windows installer for Mu."
	@echo "make video - create an mp4 video representing code commits.\n"

clean:
	rm -rf build
	rm -rf dist
	rm -rf mu_editor.egg-info
	rm -rf .coverage
	rm -rf .eggs
	rm -rf docs/_build
	rm -rf .pytest_cache
	rm -rf lib
	rm -rf pynsist_pkgs
	rm -rf pynsist_tkinter*
	rm -rf macOS
	rm -rf *.mp4
	rm -rf .git/avatar/*
	find . \( -name '*.py[co]' -o -name dropin.cache \) -delete
	find . \( -name '*.bak' -o -name dropin.cache \) -delete
	find . \( -name '*.tgz' -o -name dropin.cache \) -delete
	find . | grep -E "(__pycache__)" | xargs rm -rf

run: clean
ifeq ($(VIRTUAL_ENV),)
	@echo "\n\nCannot run Mu. Your Python virtualenv is not activated."
else
	python run.py
endif

pyflakes:
	find . \( -name _build -o -name var -o -path ./docs -o -path ./mu/contrib -o -path ./utils -o -path ./venv \) -type d -prune -o -name '*.py' -print0 | $(XARGS) pyflakes

pycodestyle:
	find . \( -name _build -o -name var \) -type d -prune -o -name '*.py' -print0 | $(XARGS) -n 1 pycodestyle --repeat --exclude=build/*,docs/*,mu/contrib*,mu/modes/api/*,utils/*,venv/*,.vscode/* --ignore=E731,E402,W504

test: clean
	pytest

coverage: clean
	pytest --cov-config .coveragerc --cov-report term-missing --cov=mu tests/

check: clean pycodestyle pyflakes coverage

dist: check
	@echo "\nChecks pass, good to package..."
	python setup.py sdist bdist_wheel

publish-test: dist
	@echo "\nPackaging complete... Uploading to PyPi..."
	twine upload -r test --sign dist/*

publish-live: dist 
	@echo "\nPackaging complete... Uploading to PyPi..."
	twine upload --sign dist/*

docs: clean
	$(MAKE) -C docs html
	@echo "\nDocumentation can be found here:"
	@echo file://`pwd`/docs/_build/html/index.html
	@echo "\n"

translate:
	find . \( -name _build -o -name var -o -path ./docs -o -path ./mu/contrib -o -path ./utils -o -path ./mu/modes/api \) -type d -prune -o -name '*.py' -print0 | $(XARGS) pygettext
	@echo "\nNew messages.pot file created."
	@echo "Remember to update the translation strings found in the locale directory."

translateall:
	pygettext mu/* mu/debugger/* mu/modes/* mu/resources/*
	@echo "\nNew messages.pot file created."
	@echo "Remember to update the translation strings found in the locale directory."

win32: check
	@echo "\nBuilding 32bit Windows installer."
	python win_installer.py 32

win64: check
	@echo "\nBuilding 64bit Windows installer."
	python win_installer.py 64

video: clean
	@echo "\nFetching contributor avatars."
	python utils/avatar.py
	@echo "\nMaking video of source commits."
	gource --user-image-dir .git/avatar/ --title "The Making of Mu" --logo ~/Pictures/icon.png --font-size 24 --file-idle-time 0 --key -1280x720 -s 0.1 --auto-skip-seconds .1 --multi-sampling --stop-at-end --hide mouse,progress --output-ppm-stream - --output-framerate 30 | ffmpeg -y -r 30 -f image2pipe -vcodec ppm -i - -b 65536K movie.mp4

=== requirements.txt ===
appdirs
beautifulsoup4
coverage
gpiozero
guizero
matplotlib
nudatus
qscintilla
qtconsole
pgzero
pigpio
Pillow
pycodestyle
pyflakes
pynsist
pyqt5
PyQtChart
pyserial
pytest
pytest-cov
pytest-random-order
requests
semver
scrapy
setuptools
sphinx
twine
wheel

=== debian/changelog ===
mu-editor (1.0.1+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #901461)

 -- Nick Morrott <knowledgejunkie@gmail.com>  Mon, 31 Dec 2018 21:15:58 +0100

=== debian/control ===
Source: mu-editor
Section: python
Priority: optional
Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Uploaders: Nick Morrott <knowledgejunkie@gmail.com>
Build-Depends:
 debhelper (>= 11),
 dh-python,
 fonts-inconsolata,
 pandoc,
 python3-all (>= 3.6),
 python3-appdirs (>= 1.4.3),
 python3-bs4,
 python3-matplotlib (>= 2.2.2),
 python3-mock,
 python3-nudatus,
 python3-pil,
 python3-pycodestyle (>= 2.4.0),
 python3-pyflakes (>= 2.0.0),
 python3-pyqt5 (>= 5.11.3),
 python3-pyqt5.qsci (>= 2.10.4),
 python3-pyqt5.qtchart (>= 5.10.1),
 python3-pyqt5.qtserialport (>= 5.11.3),
 python3-pytest,
 python3-pytest-xvfb,
 python3-qtconsole (>= 4.3.1),
 python3-requests,
 python3-scrapy,
 python3-semver (>= 2.0.1),
 python3-serial (>= 3.4),
 python3-setuptools,
 python3-sphinx,
 python3-tk,
 python3-uflash,
Standards-Version: 4.3.0
Homepage: https://codewith.mu/
Vcs-Browser: https://salsa.debian.org/python-team/applications/mu-editor
Vcs-Git: https://salsa.debian.org/python-team/applications/mu-editor.git

Package: mu-editor
Architecture: all
Depends:
 fonts-inconsolata,
 python3 (>= 3.6),
 python3-bs4,
 python3-guizero,
 python3-pyqt5,
 python3-pyqt5.qsci,
 python3-pyqt5.qtchart,
 python3-pyqt5.qtserialport,
 python3-qtconsole,
 python3-scrapy,
 python3-uflash,
 ${misc:Depends},
 ${python3:Depends},
Suggests:
 mu-editor-doc,
# pigpio,
#   Please see the RFP discussion for packaging pigpio at
#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=908787
# python3-gpiozero [armel armhf],
#   Please see the request to provide the gpiozero package on non-armhf
#   architectures at https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=856413
Description: simple editor for beginner Python programmers
 Mu is a simple code editor for beginner programmers, based on extensive
 feedback from teachers and learners. Having said that, Mu is for anyone
 who wants to use a simple "no frills" editor.
 .
 Mu is a modal editor with modes for:
 .
  * standard Python 3 (including a graphical debugger)
  * the micro:bit's version of MicroPython
  * Adafruit's CircuitPython
  * Pygame Zero
 .
 Some of the modes make available a REPL (either running on the connected
 CircuitPython or MicroPython device, or as a Jupyter-based iPython session
 in Python3 mode).
 .
 This package contains the Mu editor. Detailed online user documentation
 and tutorials for the Mu editor are available from within the editor,
 or at https://codewith.mu

Package: mu-editor-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Suggests:
 www-browser,
Description: simple editor for beginner Python programmers (documentation)
 Mu is a simple code editor for beginner programmers, based on extensive
 feedback from teachers and learners. Having said that, Mu is for anyone
 who wants to use a simple "no frills" editor.
 .
 Mu is a modal editor with modes for:
 .
  * standard Python 3 (including a graphical debugger)
  * the micro:bit's version of MicroPython
  * Adafruit's CircuitPython
  * Pygame Zero
 .
 Some of the modes make available a REPL (either running on the connected
 CircuitPython or MicroPython device, or as a Jupyter-based iPython session
 in Python3 mode).
 .
 This package contains the developer documentation for the Mu editor. Detailed
 user documentation and tutorials for the Mu editor are available from within
 the editor, or at https://codewith.mu

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_ALWAYS_EXCLUDE=__pycache__

export DH_VERBOSE=1
export PYBUILD_VERBOSE=1

export LC_ALL=C.UTF-8

export PYBUILD_NAME=mu-editor
export PYBUILD_DESTDIR_python3=debian/$(PYBUILD_NAME)

export PYBUILD_TEST_PYTEST = 1
export PYBUILD_BEFORE_TEST = mkdir -p {build_dir}/mu/resources/fonts; \
                             cp /usr/share/fonts/truetype/inconsolata/Inconsolata.otf \
                             {build_dir}/mu/resources/fonts/Inconsolata.otf
export PYBUILD_AFTER_TEST  = rm -rf {build_dir}/mu/resources/fonts

export PYBUILD_INSTALL_ARGS=--install-lib=/usr/share/mu-editor/ --install-scripts=/usr/share/mu-editor/

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_clean:
#	dh_auto_clean
#	rm -rf docs/html

override_dh_auto_build:
	dh_auto_build
	# build custom manpage
	@echo DEB_VERSION_UPSTREAM $(DEB_VERSION_UPSTREAM)
	sed -e "s/__VERSION__/$(DEB_VERSION_UPSTREAM)/g" \
				< debian/mu-editor.1.md.in > debian/mu-editor.1.md
	pandoc debian/mu-editor.1.md -s -f markdown -t man -o debian/mu-editor.1
	# build documentation
	PYTHONPATH=. http_proxy='127.0.0.1:9' https_proxy='127.0.0.1:9' python3 -m sphinx -N -bhtml docs/ docs/html

override_dh_auto_test:
	xvfb-run -a dh_auto_test

ifeq ($(DEB_HOST_ARCH_OS),linux)
override_dh_installudev:
	# Honour upstream's desired priority
	dh_installudev --priority=90
endif

## mu-editor 1.0.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -54,10 +54,10 @@
 	find . \( -name _build -o -name var \) -type d -prune -o -name '*.py' -print0 | $(XARGS) -n 1 pycodestyle --repeat --exclude=build/*,docs/*,mu/contrib*,mu/modes/api/*,utils/*,venv/*,.vscode/* --ignore=E731,E402,W504
 
 test: clean
-	pytest
+	pytest --random-order
 
 coverage: clean
-	pytest --cov-config .coveragerc --cov-report term-missing --cov=mu tests/
+	pytest --random-order --cov-config .coveragerc --cov-report term-missing --cov=mu tests/
 
 check: clean pycodestyle pyflakes coverage
 
@@ -69,7 +69,7 @@
 	@echo "\nPackaging complete... Uploading to PyPi..."
 	twine upload -r test --sign dist/*
 
-publish-live: dist 
+publish-live: dist
 	@echo "\nPackaging complete... Uploading to PyPi..."
 	twine upload --sign dist/*

=== requirements.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 pyserial
 pytest
 pytest-cov
-pytest-random-order
+pytest-random-order>=1.0.0
 requests
 semver
 scrapy

=== debian/changelog ===
mu-editor (1.0.2+dfsg-4build1) focal; urgency=medium

  * Re-upload to focal

 -- Matthias Klose <doko@ubuntu.com>  Thu, 23 Jan 2020 11:02:12 +0100

mu-editor (1.0.2+dfsg-4) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.
  * Bump Standards-Version to 4.4.1.

  [ Nick Morrott ]
  * d/control:
    - Uploaders: use my new Debian address
    - Expand definition of "REPL" in long description
    - Mark mu-editor-doc as M-A: foreign
    - Add Rules-Requires-Root field
    - Depend on default python3 rather than python3-all
  * d/tests/mu-editor:
    - Run autopkgtests against default python3. Thanks to
      Steve Langasek for the patch (Closes: #943449)
  * d/patches:
    - add use-https-urls-in-appstream-data

 -- Nick Morrott <nickm@debian.org>  Mon, 04 Nov 2019 12:30:14 +0000

mu-editor (1.0.2+dfsg-3) unstable; urgency=medium

  * d/patches: add update-rtp-for-mu-debug (Closes: #930270)
    - adapted from patch from Peter Green

 -- Nick Morrott <knowledgejunkie@gmail.com>  Tue, 18 Jun 2019 01:34:00 +0100

mu-editor (1.0.2+dfsg-2) unstable; urgency=medium

  * d/gbp.conf: use pristine-tar
  * d/patches: add test_app_icon_as_string (Closes: #923402)

 -- Nick Morrott <knowledgejunkie@gmail.com>  Thu, 28 Feb 2019 02:43:16 +0000

mu-editor (1.0.2+dfsg-1) unstable; urgency=medium

  * New upstream version 1.0.2+dfsg
  * d/control: refresh (build) dependencies
  * d/{control,compat}: bump debhelper compatibility level to 12
  * d/patches: refresh patches (Closes: #919260)
  * d/{rules,tests/mu-editor}: restore test randomisation

 -- Nick Morrott <knowledgejunkie@gmail.com>  Wed, 16 Jan 2019 03:11:03 +0000

=== debian/control ===
Source: mu-editor
Section: python
Priority: optional
Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Uploaders: Nick Morrott <nickm@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 dh-python,
 fonts-inconsolata,
 pandoc,
 python3 (>= 3.6),
 python3-appdirs (>= 1.4.3),
 python3-matplotlib (>= 2.2.2),
 python3-mock,
 python3-nudatus,
 python3-pil,
 python3-pycodestyle (>= 2.4.0),
 python3-pyflakes (>= 2.0.0),
 python3-pyqt5 (>= 5.11.3),
 python3-pyqt5.qsci (>= 2.10.4),
 python3-pyqt5.qtchart (>= 5.10.1),
 python3-pyqt5.qtserialport (>= 5.11.3),
 python3-pytest,
 python3-pytest-random-order,
 python3-pytest-xvfb,
 python3-qtconsole (>= 4.3.1),
 python3-requests,
 python3-semver (>= 2.0.1),
 python3-serial (>= 3.4),
 python3-setuptools,
 python3-sphinx,
 python3-tk,
 python3-uflash,
Rules-Requires-Root: no
Standards-Version: 4.4.1
Homepage: https://codewith.mu/
Vcs-Browser: https://salsa.debian.org/python-team/applications/mu-editor
Vcs-Git: https://salsa.debian.org/python-team/applications/mu-editor.git

Package: mu-editor
Architecture: all
Depends:
 fonts-inconsolata,
 python3 (>= 3.6),
 python3-guizero,
 python3-pyqt5,
 python3-pyqt5.qsci,
 python3-pyqt5.qtchart,
 python3-pyqt5.qtserialport,
 python3-qtconsole,
 python3-uflash,
 ${misc:Depends},
 ${python3:Depends},
Suggests:
 mu-editor-doc,
# python3-gpiozero [armel armhf],
#  Please monitor the request to provide the gpiozero package on non-armhf
#  architectures at https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=856413
 python3-pigpio,
Description: simple editor for beginner Python programmers
 Mu is a simple code editor for beginner programmers, based on extensive
 feedback from teachers and learners. Having said that, Mu is for anyone
 who wants to use a simple "no frills" editor.
 .
 Mu is a modal editor with modes for:
 .
  * standard Python 3 (including a graphical debugger)
  * the micro:bit's version of MicroPython
  * Adafruit's CircuitPython
  * Pygame Zero
 .
 Some modes provide read-eval-print loop (REPL) support, either running on
 a connected CircuitPython or MicroPython device, or as a Jupyter-based
 iPython session in Python3 mode.
 .
 This package contains the Mu editor. Detailed online user documentation
 and tutorials for the Mu editor are available from within the editor,
 or at https://codewith.mu

Package: mu-editor-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Suggests:
 www-browser,
Description: simple editor for beginner Python programmers (documentation)
 Mu is a simple code editor for beginner programmers, based on extensive
 feedback from teachers and learners. Having said that, Mu is for anyone
 who wants to use a simple "no frills" editor.
 .
 Mu is a modal editor with modes for:
 .
  * standard Python 3 (including a graphical debugger)
  * the micro:bit's version of MicroPython
  * Adafruit's CircuitPython
  * Pygame Zero
 .
 Some modes provide read-eval-print loop (REPL) support, either running on
 a connected CircuitPython or MicroPython device, or as a Jupyter-based
 iPython session in Python3 mode.
 .
 This package contains the developer documentation for the Mu editor. Detailed
 user documentation and tutorials for the Mu editor are available from within
 the editor, or at https://codewith.mu

=== debian/tests/control ===
Tests: mu-editor
Depends: @builddeps@, @,

## mu-editor 1.0.3+dfsg

=== debian/changelog ===
mu-editor (1.0.3+dfsg-3) unstable; urgency=medium

  * d/control:
    - Update standards version to 4.6.0, no changes needed.
    - Drop unnecessary version constraints for dependencies
  * d/copyright:
    - Refresh years of Debian copyright
    - Use 4-digit years for Debian copyright ranges
  * d/patches:
    - Add patch fix-missing-kernel-attr-qtkernelmanager (Closes: #1005259)
    - Add patch fix-semver-deprecation-warnings
  * d/s/lintian-overrides:
    - Add override for long lines in source
  * d/u/metadata:
    - Remove unknown field Bug-Repository
  * d/watch:
    - Update pattern for GitHub archive URLs

 -- Nick Morrott <nickm@debian.org>  Tue, 15 Feb 2022 01:39:04 +0000

mu-editor (1.0.3+dfsg-2) unstable; urgency=medium

  [ Debian Janitor ]
  * d/u/metadata:
    - Set upstream metadata fields: Bug-Database.
    - Remove obsolete fields Contact, Name (already present in
      machine-readable debian/copyright).

  [ Ondřej Nový ]
  * d/control:
    - Update Maintainer field with new Debian Python Team contact address.
    - Update Vcs-* fields with new Debian Python Team Salsa layout.

  [ Nick Morrott ]
  * d/control:
    - Declare compliance with Debian Policy 4.5.1
  * d/copyright:
    - Refresh lists of source files (redundant globbing patterns)
    - Refresh years of Debian copyright and contact email address
  * d/mu-editor.lintian-overrides:
    - Add override for Python egg metadata
  * d/salsa-ci.yml:
    - Add Salsa CI pipeline

 -- Nick Morrott <nickm@debian.org>  Sun, 07 Feb 2021 13:35:47 +0000

mu-editor (1.0.3+dfsg-1) unstable; urgency=medium

  * New upstream version 1.0.3+dfsg
  * d/control:
    - Declare compliance with Debian Policy 4.5.0
    - Bump debhelper compatibility level to 13
    - Add Suggests on python3-gpiozero (arch:any since buster)
  * d/patches:
    - Refresh patch soften-dependency-versions
    - Drop patch test_app_icon_as_string (applied upstream)

 -- Nick Morrott <nickm@debian.org>  Sat, 13 Jun 2020 06:12:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,47 +1,47 @@
 Source: mu-editor
 Section: python
 Priority: optional
-Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
+Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Nick Morrott <nickm@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-python,
  fonts-inconsolata,
  pandoc,
- python3 (>= 3.6),
- python3-appdirs (>= 1.4.3),
- python3-matplotlib (>= 2.2.2),
+ python3,
+ python3-appdirs,
+ python3-matplotlib,
  python3-mock,
  python3-nudatus,
  python3-pil,
- python3-pycodestyle (>= 2.4.0),
- python3-pyflakes (>= 2.0.0),
- python3-pyqt5 (>= 5.11.3),
- python3-pyqt5.qsci (>= 2.10.4),
- python3-pyqt5.qtchart (>= 5.10.1),
- python3-pyqt5.qtserialport (>= 5.11.3),
+ python3-pycodestyle,
+ python3-pyflakes,
+ python3-pyqt5,
+ python3-pyqt5.qsci,
+ python3-pyqt5.qtchart,
+ python3-pyqt5.qtserialport,
  python3-pytest,
  python3-pytest-random-order,
  python3-pytest-xvfb,
- python3-qtconsole (>= 4.3.1),
+ python3-qtconsole,
  python3-requests,
- python3-semver (>= 2.0.1),
- python3-serial (>= 3.4),
+ python3-semver,
+ python3-serial,
  python3-setuptools,
  python3-sphinx,
  python3-tk,
  python3-uflash,
 Rules-Requires-Root: no
-Standards-Version: 4.4.1
+Standards-Version: 4.6.0
 Homepage: https://codewith.mu/
-Vcs-Browser: https://salsa.debian.org/python-team/applications/mu-editor
-Vcs-Git: https://salsa.debian.org/python-team/applications/mu-editor.git
+Vcs-Browser: https://salsa.debian.org/python-team/packages/mu-editor
+Vcs-Git: https://salsa.debian.org/python-team/packages/mu-editor.git
 
 Package: mu-editor
 Architecture: all
 Depends:
  fonts-inconsolata,
- python3 (>= 3.6),
+ python3,
  python3-guizero,
  python3-pyqt5,
  python3-pyqt5.qsci,
@@ -53,9 +53,7 @@
  ${python3:Depends},
 Suggests:
  mu-editor-doc,
-# python3-gpiozero [armel armhf],
-#  Please monitor the request to provide the gpiozero package on non-armhf
-#  architectures at https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=856413
+ python3-gpiozero,
  python3-pigpio,
 Description: simple editor for beginner Python programmers
  Mu is a simple code editor for beginner programmers, based on extensive

=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,7 @@
 export PYBUILD_BEFORE_TEST = mkdir -p {build_dir}/mu/resources/fonts; \
                              cp /usr/share/fonts/truetype/inconsolata/Inconsolata.otf \
                              {build_dir}/mu/resources/fonts/Inconsolata.otf
+export PYBUILD_TEST_ARGS   = --random-order
 export PYBUILD_AFTER_TEST  = rm -rf {build_dir}/mu/resources/fonts
 
 export PYBUILD_INSTALL_ARGS=--install-lib=/usr/share/mu-editor/ --install-scripts=/usr/share/mu-editor/
@@ -24,8 +25,8 @@
 	dh $@ --with python3,sphinxdoc --buildsystem=pybuild
 
 override_dh_auto_clean:
-#	dh_auto_clean
-#	rm -rf docs/html
+	dh_auto_clean
+	rm -rf docs/html
 
 override_dh_auto_build:
 	dh_auto_build

## mu-editor 1.2.0%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
                              cp /usr/share/fonts/truetype/inconsolata/Inconsolata.otf \
                              {build_dir}/mu/resources/fonts/Inconsolata.otf
 export PYBUILD_TEST_ARGS   = --random-order
-export PYBUILD_AFTER_TEST  = rm -rf {build_dir}/mu/resources/fonts
+export PYBUILD_AFTER_TEST  = rm -rf {build_dir}/mu/resources/fonts {build_dir}/.pytest_cache
 
 export PYBUILD_INSTALL_ARGS=--install-lib=/usr/share/mu-editor/ --install-scripts=/usr/share/mu-editor/
 
@@ -27,6 +27,7 @@
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -rf docs/html
+	rm -f debian/mu-editor.1.md debian/mu-editor.1
 
 override_dh_auto_build:
 	dh_auto_build
@@ -39,7 +40,7 @@
 	PYTHONPATH=. http_proxy='127.0.0.1:9' https_proxy='127.0.0.1:9' python3 -m sphinx -N -bhtml docs/ docs/html
 
 override_dh_auto_test:
-	xvfb-run -a dh_auto_test
+	export LANG=C.UTF-8; xvfb-run -a dh_auto_test
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 override_dh_installudev:

## mu-editor 1.2.0+dfsg

=== Makefile ===
XARGS := xargs -0 $(shell test $$(uname) = Linux && echo -r)
GREP_T_FLAG := $(shell test $$(uname) = Linux && echo -T)
export PYFLAKES_BUILTINS=_

all:
	@echo "\nThere is no default Makefile target right now. Try:\n"
	@echo "make run - run the local development version of Mu."
	@echo "make clean - reset the project and remove auto-generated assets."
	@echo "make flake8 - run the flake8 code checker."
	@echo "make test - run the test suite."
	@echo "make coverage - view a report on test coverage."
	@echo "make tidy - tidy code with the 'black' formatter."
	@echo "make check - run all the checkers and tests."
	@echo "make dist - make a dist/wheel for the project."
	@echo "make publish-test - publish the project to PyPI test instance."
	@echo "make publish-live - publish the project to PyPI production."
	@echo "make docs - run sphinx to create project documentation."
	@echo "make translate_begin LANG=xx_XX - create/update a mu.po file for translation."
	@echo "make translate_done LANG=xx_XX - compile translation strings in mu.po to mu.mo file."
	@echo "make translate_test LANG=xx_XX - run translate_done and launch Mu in the given LANG."
	@echo "make win32 - create a 32bit Windows installer for Mu."
	@echo "make win64 - create a 64bit Windows installer for Mu."
	@echo "make macos - create a macOS native application for Mu."
	@echo "make video - create an mp4 video representing code commits.\n"

clean:
	rm -rf build
	rm -rf dist
	rm -rf .coverage
	rm -rf .eggs
	rm -rf *.egg-info
	rm -rf docs/_build
	rm -rf .pytest_cache
	rm -rf lib
	rm -rf *.mp4
	rm -rf .git/avatar/*
	rm -rf venv-pup
	find . \( -name '*.py[co]' -o -name dropin.cache \) -delete
	find . \( -name '*.bak' -o -name dropin.cache \) -delete
	find . \( -name '*.tgz' -o -name dropin.cache \) -delete
	find . | grep -E "(__pycache__)" | xargs rm -rf
	rm -f ./mu/locale/messages.pot
	rm -f ./mu/wheels/*.zip

run: clean
ifeq ($(VIRTUAL_ENV),)
	@echo "\n\nCannot run Mu. Your Python virtualenv is not activated."
else
	python run.py
endif

flake8:
	@python make.py flake8

test: clean
	export LANG=en_GB.utf8
	pytest -v --random-order

coverage: clean
	export LANG=en_GB.utf8
	pytest -v --random-order --cov-config .coveragerc --cov-report term-missing --cov=mu tests/

tidy: 
	python make.py tidy

black:
	python make.py black

check: clean black flake8 coverage

dist: check
	@echo "\nChecks pass, good to package..."
	python setup.py sdist bdist_wheel

publish-test: dist
	@echo "\nPackaging complete... Uploading to PyPi..."
	twine upload -r test --sign dist/*

publish-live: dist
	@echo "\nPackaging complete... Uploading to PyPi..."
	twine upload --sign dist/*

docs:
	@python make.py docs
	@echo "\nDocumentation can be found here:"
	@echo file://`pwd`/docs/_build/html/index.html
	@echo "\n"

translate_begin:
	@python make.py translate_begin LANG=$(LANG)

translate_done:
	@python make.py translate_done LANG=$(LANG)

translate_test:
	@python make.py translate_test LANG=$(LANG)

win32: check
	@echo "\nBuilding 32bit Windows MSI installer."
	python make.py win32

win64: check
	@echo "\nBuilding 64bit Windows MSI installer."
	python make.py win64

macos: check
	@echo "\nFetching wheels."
	python -m mu.wheels --package
	@echo "\nPackaging Mu into a macOS native application."
	python -m virtualenv venv-pup
	# Don't activate venv-pup because:
	# 1. Not really needed.
	# 2. Previously active venv would be "gone" on venv-pup deactivation.
	./venv-pup/bin/pip install pup
	./venv-pup/bin/pup package --launch-module=mu --nice-name="Mu Editor" --icon-path=./package/icons/mac_icon.icns --license-path=./LICENSE .
	rm -r venv-pup
	ls -la ./build/pup/
	ls -la ./dist/

linux: check
	@echo "\nFetching wheels."
	python -m mu.wheels --package
	@echo "\nPackaging Mu into a Linux AppImage."
	python -m virtualenv venv-pup
	# Don't activate venv-pup because:
	# 1. Not really needed.
	# 2. Previously active venv would be "gone" on venv-pup deactivation.
	./venv-pup/bin/pip install pup
	./venv-pup/bin/pup package --launch-module=mu --nice-name="Mu Editor" --icon-path=./mu/resources/images/icon.png --license-path=./LICENSE .
	rm -r venv-pup
	ls -la ./build/pup/
	ls -la ./dist/

video: clean
	@echo "\nFetching contributor avatars."
	python utils/avatar.py
	@echo "\nMaking video of source commits."
	gource --user-image-dir .git/avatar/ --title "The Making of Mu" --logo docs/icon_small.png --font-size 24 --file-idle-time 0 --key -1280x720 -s 0.1 --auto-skip-seconds .1 --multi-sampling --stop-at-end --hide mouse,progress --output-ppm-stream - --output-framerate 30 | ffmpeg -y -r 30 -f image2pipe -vcodec ppm -i - -b 65536K movie.mp4

=== requirements.txt ===
# Mu doesn't use requirements.txt:
# - To install please refer to https://codewith.mu/.
# - To setup a development environment see https://mu.readthedocs.io/.

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = python -msphinx
SPHINXPROJ    = Mu
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
mu-editor (1.2.0+dfsg-3) unstable; urgency=medium

  * applied Chris Lamb's patch, thanks! Closes: #1120332

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 08 Nov 2025 19:07:32 +0100

mu-editor (1.2.0+dfsg-2) unstable; urgency=medium

  * added the build dependency python3-pyqt5.qtsvg. Closes: #1093475

 -- Georges Khaznadar <georgesk@debian.org>  Mon, 20 Jan 2025 10:34:57 +0100

mu-editor (1.2.0+dfsg-1) unstable; urgency=medium

  [ Nick Morrott ]
  * New upstream version 1.1.0~alpha2+dfsg1

  [ Alexandre Detiste ]
  * remove extraneous dependency on python3-mock
  * New upstream version 1.2.0+dfsg

  [ Nick Morrott ]
  * d/control: refresh long descriptions with new modes
  * d/copyright: refresh in preparation for import of 1.1.0-alpha

  [ Georges Khaznadar ]
  * declared myself as maintainer. Closes: #1079233
  * updated debian patches, some of them are deleted.
  * patched one test, because the module adafruit_board_toolkit is missing
  * stable is now bookworm, so we may disregard #1027378. Closes: #1027378
  * patched some tests. Closes: #998297; Closes: #1081083
  * removed the build-dependency on python3-apprdirs. Closes: #1067972
  * added build dependencies: python3-virtualenv, black
  * bumped Standards-Version: 4.7.0
  * applied Petter Reinholdtsen's patch, to enrich metadata. Closes: #1079039
  * patched mu/weels/__init__.py to define a standard writable location
    path for the wheel ZIP file (outside the applications's path!)

 -- Georges Khaznadar <georgesk@debian.org>  Fri, 08 Nov 2024 16:13:03 +0100

mu-editor (1.0.3+dfsg-6) unstable; urgency=medium

  * d/patches:
    - Add patch disable-microbit-mount-tests (Closes: #1027378)

 -- Nick Morrott <nickm@debian.org>  Thu, 09 Feb 2023 05:17:47 +0000

mu-editor (1.0.3+dfsg-5) unstable; urgency=medium

  * d/control:
    - Declare compliance with Debian Policy 4.6.2 (no changes)
  * d/copyright:
    - Bump years of Debian copyright
  * d/mu-editor.lintian-overrides:
    - Refresh overrides
  * d/patches:
    - Add patch tests-reduce-builtin-mock-scope

 -- Nick Morrott <nickm@debian.org>  Thu, 09 Feb 2023 03:20:50 +0000

mu-editor (1.0.3+dfsg-4) unstable; urgency=medium

  * d/patches:
    - Add patch avoid-floats-for-int-arguments

 -- Nick Morrott <nickm@debian.org>  Tue, 17 May 2022 23:42:29 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,14 @@
 Source: mu-editor
 Section: python
 Priority: optional
-Maintainer: Debian Python Team <team+python@tracker.debian.org>
-Uploaders: Nick Morrott <nickm@debian.org>
+Maintainer: Georges Khaznadar <georgesk@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  dh-python,
  fonts-inconsolata,
  pandoc,
  python3,
- python3-appdirs,
  python3-matplotlib,
- python3-mock,
  python3-nudatus,
  python3-pil,
  python3-pycodestyle,
@@ -20,6 +17,7 @@
  python3-pyqt5.qsci,
  python3-pyqt5.qtchart,
  python3-pyqt5.qtserialport,
+ python3-pyqt5.qtsvg,
  python3-pytest,
  python3-pytest-random-order,
  python3-pytest-xvfb,
@@ -32,7 +30,7 @@
  python3-tk,
  python3-uflash,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Homepage: https://codewith.mu/
 Vcs-Browser: https://salsa.debian.org/python-team/packages/mu-editor
 Vcs-Git: https://salsa.debian.org/python-team/packages/mu-editor.git
@@ -49,6 +47,8 @@
  python3-pyqt5.qtserialport,
  python3-qtconsole,
  python3-uflash,
+ python3-virtualenv,
+ black,
  ${misc:Depends},
  ${python3:Depends},
 Suggests:
@@ -63,9 +63,11 @@
  Mu is a modal editor with modes for:
  .
   * standard Python 3 (including a graphical debugger)
-  * the micro:bit's version of MicroPython
-  * Adafruit's CircuitPython
+  * MicroPython on the BBC micro:bit
+  * MicroPython on ESP8266/ESP32 boards
+  * CircuitPython on Adafruit/Particle/Electronic Cats/SparkFun boards
   * Pygame Zero
+  * Web development (using Flask)
  .
  Some modes provide read-eval-print loop (REPL) support, either running on
  a connected CircuitPython or MicroPython device, or as a Jupyter-based
@@ -92,9 +94,11 @@
  Mu is a modal editor with modes for:
  .
   * standard Python 3 (including a graphical debugger)
-  * the micro:bit's version of MicroPython
-  * Adafruit's CircuitPython
+  * MicroPython on the BBC micro:bit
+  * MicroPython on ESP8266/ESP32 boards
+  * CircuitPython on Adafruit/Particle/Electronic Cats/SparkFun boards
   * Pygame Zero
+  * Web development (using Flask)
  .
  Some modes provide read-eval-print loop (REPL) support, either running on
  a connected CircuitPython or MicroPython device, or as a Jupyter-based

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//, repacksuffix=+dfsg, filenamemangle=s/.+\/v?@ANY_VERSION@\.tar\.gz/@PACKAGE@-$1\.tar\.gz/" https://github.com/mu-editor/mu/tags .*/archive/refs/tags/v?@ANY_VERSION@@ARCHIVE_EXT@
